SystemOrganization addCategory: #'GMF-Generator'!
SystemOrganization addCategory: #'GMF-Generator-Tests'!

TestCase subclass: #TestCodeGenerator
	instanceVariableNames: 'gAll rightClasses package pacakge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator-Tests'!

!TestCodeGenerator methodsFor: 'initialize-release' stamp: 'RostsilavNovk 7/24/2013 00:22'!
setUp
| vLive mIsLive cBeing vBirthNumber vName vDateOfBirth vAnimals mAge cPerson cMan cWoman mEat mSound cAnimal cDog vHusban vWife aOneToOne cChild vChildrens vMother aOnteToMany vBoyFriend vGirlFriend aManyToMany |
vLive := GeneratedEOCVariable newName: 'live'.
mIsLive := GeneratedEOCMethod  newName: 'isLive'.
cBeing := GeneratedClass newName:  'Being'.
cBeing addVariable: vLive.
cBeing addMethod: mIsLive.

vBirthNumber := GeneratedEOCVariable newName: 'birthNumber'.
vName := GeneratedEOCVariable newName: 'name'.
vDateOfBirth := GeneratedEOCVariable newName: 'dateOfBirth'.
vAnimals := GeneratedEOCVariable newName: 'animals'.
vAnimals collection: 'OrderedCollection'.
mAge := GeneratedEOCMethod  newName: 'age'.
cPerson := GeneratedClass newName: 'Person'.
cPerson parent: cBeing.
cPerson addVariable: vBirthNumber.
cPerson addVariable: vName.
cPerson addVariable: vDateOfBirth.
cPerson addVariable: vAnimals.
cPerson addMethod: mAge.

cMan := GeneratedClass newName: 'Man'.
cMan parent: cPerson.
cWoman := GeneratedClass newName: 'Woman'.
cWoman parent: cPerson.

mEat := GeneratedEOCMethod newName: 'eat' Abstract: true.
mEat addArgument: (GeneratedEOCVariable newName: 'food').
mSound := GeneratedEOCMethod newName: 'sound' Instance: false Abstract: true.
cAnimal := GeneratedClass newName: 'Animal'.
cAnimal addMethod: mEat.
cAnimal addMethod: mSound.
cAnimal parent: cBeing.

mEat := GeneratedEOCMethod newName: 'eat'.
mEat addArgument: (GeneratedEOCVariable newName: 'food').
mSound := GeneratedEOCMethod newName: 'sound' Instance: false.
cDog := GeneratedClass newName: 'Dog'.
cDog addMethod: mEat.
cDog addMethod: mSound.
cDog parent: cAnimal.

vHusban := GeneratedEOCVariable newName: 'husban'.
vWife:= GeneratedEOCVariable newName: 'wife'.
aOneToOne := GeneratedAssociation newLeft: cMan Var: vWife RIght: cWoman Var: vHusban.
cMan association: aOneToOne.
cWoman association: aOneToOne.

cChild := GeneratedClass newName: 'Child'.
cChild parent: cPerson.
vChildrens := GeneratedEOCVariable newName: 'childrens'.
vChildrens collection: 'OrderedCollection'.
vMother:= GeneratedEOCVariable newName: 'mother'.
aOnteToMany := GeneratedAssociation  newLeft: cWoman Var: vChildrens RIght: cChild Var: vMother.
cWoman association: aOnteToMany.
cChild association: aOnteToMany.

vBoyFriend := GeneratedEOCVariable newName: 'boyFriends'.
vBoyFriend collection: 'OrderedCollection'.
vGirlFriend := GeneratedEOCVariable newName: 'girlFriends'.
vGirlFriend collection: 'OrderedCollection'.
aManyToMany := GeneratedAssociation  newLeft: cMan Var: vGirlFriend RIght: cWoman Var: vBoyFriend.
cMan association: aManyToMany.
cWoman association: aManyToMany.

gAll := GeneratedAll new.
gAll addClass: cDog.
gAll addClass: cWoman.
gAll addClass: cMan.
gAll addClass: cAnimal.
gAll addClass: cPerson.
gAll addClass: cBeing.
gAll addClass: cChild.

rightClasses := SortedCollection new.
rightClasses add: 'Animal';  add: 'Being' ; add: 'Child'; add: 'Dog'; add: 'Man'; add:'Person'; add: 'Woman'.
package := PackageInfo new.
package packageName: 'generatedClasses'.! !

!TestCodeGenerator methodsFor: 'running' stamp: 'RostsilavNovk 7/24/2013 11:49'!
testGenerator
	| classes collection |
	CodeGenerator setDataWithAll: gAll.
	
	"Test classes"
	classes := package classes.
	collection := SortedCollection new.
	classes do:[:v | collection add:(v asString)].
	"collection do:[:c | self assert: (rightClasses anySatisfy:[:r | r == c ]) ]."
	self assert: collection = rightClasses.
	"Test variables"

	"Test methods."! !

Object subclass: #AbstractGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!AbstractGenerator class methodsFor: 'accessing' stamp: 'RostsilavNovk 7/23/2013 23:21'!
generate: xObject
	^self subclassResponsibility.! !

AbstractGenerator subclass: #ClassGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

ClassGenerator class
	instanceVariableNames: 'classVariables class parent instVariables'!

ClassGenerator class
	instanceVariableNames: 'classVariables class parent instVariables'!

!ClassGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 13:17'!
addAssociations
	class association
		do: [ :a | 
			(a isLeft: self)
				ifTrue: [ class addVariable: a leftVar ]
				ifFalse: [ class addVariable: a rightVar ] ]! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 00:12'!
createClass
	self class evaluatorClass evaluate: parent , ' subclass: #' , class name,'
		instanceVariableNames: ''' , instVariables,'''
		classVariableNames: ''' , classVariables,'''
		poolDictionaries: ''''
		category: ''generatedClasses'''.! !

!ClassGenerator class methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 12:09'!
generate: xObject
	class := xObject.
	self setUpVariables.
	self setUpParent.
	self createClass.
	MethodGenerator generate: xObject.! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/23/2013 21:02'!
getStringVariables: xCollection
	| str |
	str := ''.
	xCollection size == 0
		ifFalse: [ xCollection do: [ :v | str := str, ' ' , v name ] ].
	^ str! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 00:12'!
setUpParent
	class parent isNil
		ifTrue: [ parent := 'Object' ]
		ifFalse: [ parent := class parent name ].! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 13:16'!
setUpVariables
	| instVars classVars |
	instVars := OrderedCollection new.
	classVars := OrderedCollection new.
	self addAssociations.
	class variables
		do: [ :v | 
			v isInstance
				ifTrue: [ instVars add: v ]
				ifFalse: [ classVars add: v ] ].
	instVariables := self getStringVariables: instVars.
	classVariables := self getStringVariables: classVars! !

AbstractGenerator subclass: #MethodGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!MethodGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:45'!
createMethod: xMethod Class: xClass
	| arguments isClass |
	arguments := self readMethodArguments: xMethod.
	isClass := ' '.
	xMethod isInstance
		ifFalse: [ isClass := ' class ' ].
	self class evaluatorClass
		evaluate:
			'' , xClass name , isClass , 'compile: ''' , xMethod name , arguments,
			(xMethod isAbstract
						ifTrue: [ '
			^ self subclassResponsibility' ]
						ifFalse: [ ' ' ]) , ' '' '! !

!MethodGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:06'!
createNew: xClass

	self class evaluatorClass evaluate:  '', xClass name, ' class compile: ''new ','
	^ super new
		initialize;
		yourself'' classified: ''instance creation'' '.! !

!MethodGenerator class methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 12:10'!
generate: xObject
	"Create methods."
	xObject methods size == 0
		ifFalse: [ xObject methods do: [ :m | self createMethod: m Class: xObject ] ].
	"Create additional methods."
	self createNew: xObject.
	VariableGenerator generate: xObject.! !

!MethodGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:08'!
readMethodArguments: xMethod
	^ xMethod arguments inject: '' into: [ :str :a | str , a name , ': x' , a name , ' ' ]! !

AbstractGenerator subclass: #VariableGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:47'!
createCollections: xClass
	| vars |
	vars := xClass variables select:[:v | v collection notNil ].
	^(vars inject: '' into: [:str :v | str, v name, ':=', v collection, ' new', '.
		' ])! !

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/23/2013 21:01'!
createDefaultValues
	^''.! !

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:47'!
createInitialize: xClass
	self class evaluatorClass evaluate: '' , xClass name , ' compile: ''initialize ', '
	', (self createCollections: xClass), ' 
	', self createDefaultValues, '
	', (self createNulls: xClass) , '
	 '' classified: ''initialize-release'' '.! !

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:38'!
createNulls: xClass
	| vars |
	vars := xClass variables select:[:v | v collection isNil ].
	^(vars inject: '' into: [:str :v | str, v name, ':= nil.
		' ])! !

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:37'!
createSettersGetters: xClass
	xClass variables
		do: [ :v | 
			self class evaluatorClass evaluate: '' , xClass name , ' compile: ''' , v name , '
			^' , v name , ' '' classified: ''accessing'' '.
			self class evaluatorClass evaluate: '' , xClass name , ' compile: ''' , v name ,': xVal
			' , v name , ':= xVal'' classified: ''accessing'' ' ]! !

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:39'!
createVarShaking: xClass
	| thatClass thatVar thisVar |
	xClass association
		do: [ :as | 
			as left == xClass
				ifTrue: [ 
					thatClass := as right.
					thatVar := as rightVar.
					thisVar := as leftVar ]
				ifFalse: [ 
					thatClass := as left.
					thatVar := as leftVar.
					thisVar := as rightVar ].
			thisVar collection == nil
				ifTrue: [ self class evaluatorClass evaluate: '' , xClass name , ' compile: ''' , thisVar name, ': xValue
			' , thisVar name , ' == xValue
				ifFalse: [
					xValue class == ' , thatClass name,'
				ifTrue: [ 
					' , thisVar name,' := xValue.
					' , thisVar name , ' ' , thatVar name , ': self ] ] '' classified: ''accessing'' ' ]
				ifFalse: [ self class evaluatorClass evaluate: '' , xClass name , ' compile: ''' , thisVar name, ': xValue
			' , thisVar name , ' anySatisfy: [ :v | v == xValue ]
				ifFalse: [
					xValue class == ' , thatClass name,'
				ifTrue: [ 
					' , thisVar name,' add: xValue.
					xValue ' , thatVar name , ': self ] ] '' classified: ''accessing'' ' ] ]! !

!VariableGenerator class methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 12:39'!
generate: xObject
	self createSettersGetters: xObject.
	self createInitialize: xObject.
	self createVarShaking: xObject.! !

Object subclass: #CodeGenerator
	instanceVariableNames: ''
	classVariableNames: 'arguments classes data index method methods parent temp temp2 variables'
	poolDictionaries: ''
	category: 'GMF-Generator'!

!CodeGenerator class methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 12:09'!
generateCode: interface
	self readData: interface.
	[ data classes notEmpty ] whileTrue: [ self readNextClass ]! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/5/2013 14:16'!
readData: interface  
	data:= interface asGeneratorData.! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 11:49'!
readNextClass
	| class |
	"Take first not generated."
	class := data classes at: 1.
	self readSelectedClass: class.! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 11:49'!
readSelectedClass: xClass
	"If it has parent and it is not generated."
	xClass parent isNil
		ifFalse: [self readSelectedClass: xClass parent].
	"Generate class."
	ClassGenerator generate: xClass.
	data removeClass: xClass.! !

!CodeGenerator class methodsFor: 'testing' stamp: 'RostsilavNovk 7/24/2013 12:09'!
setDataWithAll: xData
	data := xData.
	[ data classes notEmpty ] whileTrue: [ self readNextClass ]! !

Object subclass: #GeneratedAll
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedAll class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 10:32'!
new
	^ super new
		initialize;
		yourself! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 10:31'!
addClass: aGeneratedClass
	"adding classes"

	classes add: aGeneratedClass.! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 00:54'!
classes
	^ classes copy.! !

!GeneratedAll methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 10:25'!
initialize
	"set numbers of used classes and relations to empty"

	classes := OrderedCollection new.
	^ self! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 00:46'!
removeClass: aGeneratedClass
	"remove  classes"

	classes :=  classes reject:[: c| c == aGeneratedClass ].! !

Object subclass: #GeneratedAssociation
	instanceVariableNames: 'left leftVar right rightVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedAssociation class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/19/2013 20:54'!
newLeft: xLeft Var: xLVar RIght: xRight Var: xRVar
	^ super new
		left: xLeft;
		leftVar: xLVar;
		right: xRight;
		rightVar: xRVar;
		yourself! !

!GeneratedAssociation methodsFor: 'testing' stamp: 'RostsilavNovk 7/24/2013 13:01'!
isLeft: xClass
	^left == xClass! !

!GeneratedAssociation methodsFor: 'testing' stamp: 'RostsilavNovk 7/24/2013 13:01'!
isRight: xClass
	^right == xClass! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:50'!
left
 ^left! !

!GeneratedAssociation methodsFor: 'private' stamp: 'RostislavNovk 5/19/2013 20:50'!
left: xLeft
	left := xLeft! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:51'!
leftVar
 ^leftVar! !

!GeneratedAssociation methodsFor: 'private' stamp: 'RostislavNovk 5/19/2013 20:50'!
leftVar: xLeft
	leftVar := xLeft! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:50'!
right
^right! !

!GeneratedAssociation methodsFor: 'private' stamp: 'RostislavNovk 5/19/2013 20:50'!
right: xRight
	right := xRight! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:51'!
rightVar
^rightVar! !

!GeneratedAssociation methodsFor: 'private' stamp: 'RostislavNovk 5/19/2013 20:50'!
rightVar: xRight
	rightVar := xRight! !

Object subclass: #GeneratedClass
	instanceVariableNames: 'name comment variables methods superClass generated association'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:43'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:44'!
newName: xName Comment: xComment
	^ super new
		initialize;
		name: xName;
		comment: xComment;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:44'!
newName: xName Comment: xComment Code: xCode
	^ super new
		initialize;
		name: xName;
		comment: xComment;
		code: xCode;
		yourself! !

!GeneratedClass methodsFor: 'accessing' stamp: 'JiriMertin 4/1/2013 19:27'!
addMethod: aGeneratedEOCMethod
	"add to sortedcollection"

	methods add: aGeneratedEOCMethod! !

!GeneratedClass methodsFor: 'accessing' stamp: 'JiriMertin 4/1/2013 19:27'!
addVariable: aGeneratedEOCVariable
	"add to sortedcollection"

	variables add: aGeneratedEOCVariable! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:59'!
association
	^association copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 21:42'!
association: xAs
	association add: xAs.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
comment
	^comment.! !

!GeneratedClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:50'!
comment: xComment
	comment:= xComment.! !

!GeneratedClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 5/19/2013 20:58'!
initialize
	variables:= OrderedCollection new.
	methods:= OrderedCollection new.
	association:= OrderedCollection  new.
	comment:=''.
	superClass:=nil.
	generated := false.
	! !

!GeneratedClass methodsFor: 'testing' stamp: 'RostislavNovk 4/8/2013 00:25'!
isGenerated
	^generated! !

!GeneratedClass methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 11:07'!
isSubClass
	[ superClass isNil ]
		ifTrue: [ ^ false ]
		ifFalse: [ ^ true ]! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
methods
	^methods copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
name
	^name.! !

!GeneratedClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:50'!
name: xName
	name:= xName.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
parent
	^superClass.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:50'!
parent: xGeneratedClass
	superClass:= xGeneratedClass .! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
variables
	^variables copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/8/2013 00:26'!
wasGenerated
	generated := true.! !

Object subclass: #GeneratedElementOfClass
	instanceVariableNames: 'name instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

GeneratedElementOfClass subclass: #GeneratedEOCMethod
	instanceVariableNames: 'code arguments abstract'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/13/2013 00:28'!
newName: xName
	^ (super newName: xName)
		initialize;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/13/2013 00:29'!
newName: xName Abstract: xAbstract
	^ (super newName: xName)
		initialize;
		abstract: xAbstract;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/13/2013 00:29'!
newName: xName Code: xCode
	^ (super newName: xName)
		initialize;
		code: xCode;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/13/2013 00:29'!
newName: xName Instance: xInstance Abstract: xAbstract
	^ (super newName: xName Instance: xInstance)
		initialize;
		abstract: xAbstract;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/13/2013 00:29'!
newName: xName Instance: xInstance Code: xCode
	^ (super newName: xName Instance: xInstance)
		initialize;
		code: xCode;
		yourself! !

!GeneratedEOCMethod methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 18:56'!
abstract: xAbstract
	abstract := xAbstract.! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:28'!
addArgument: xGeneratedEOCVariable
	arguments add: xGeneratedEOCVariable! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
arguments
	^ arguments copy! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
code
	^ code! !

!GeneratedEOCMethod methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:47'!
code: xCode 
	code := xCode.! !

!GeneratedEOCMethod methodsFor: 'initialize-release' stamp: 'RostislavNovk 5/13/2013 00:29'!
initialize
	abstract := false.
	instance := true.
	arguments:= OrderedCollection new.! !

!GeneratedEOCMethod methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 18:55'!
isAbstract
	^abstract! !

GeneratedElementOfClass subclass: #GeneratedEOCVariable
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedEOCVariable methodsFor: 'accessing' stamp: 'RostislavNovk 5/10/2013 20:01'!
collection
	^collection! !

!GeneratedEOCVariable methodsFor: 'accessing' stamp: 'RostislavNovk 5/10/2013 20:01'!
collection: xCollection
	collection := xCollection! !

!GeneratedElementOfClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:46'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!GeneratedElementOfClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:45'!
newName: xName Instance: xInstance
	^ super new
		name: xName;
		instance: xInstance;
		yourself! !

!GeneratedElementOfClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 18:01'!
initialize
	instance := true
! !

!GeneratedElementOfClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:51'!
instance: xInstance
	instance:=xInstance.
! !

!GeneratedElementOfClass methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 18:01'!
isClass
	"returns opposite of isInstantce"

	^ instance = false! !

!GeneratedElementOfClass methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 17:59'!
isInstance
	^ instance! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:52'!
name
	^ name! !

!GeneratedElementOfClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:51'!
name: xName
	name := xName.
! !
